/**
 *
 * This is part of the MoDeST-Plugin
 * Saarland University 2006
 * Author: Christophe Boutter (boutter@ps.uni-sb.de)
 *
 */
package modesteditor.core.antlrparser;

/**
 * @author Christophe Boutter
 *
 */
public class Symbol {
	private String type;
	private String name;
	private int line;
	private int column;
	
	public Symbol(String name, String type) {
		this.name=name;
		this.type=type;
	}
	
	public String getName() {
		return name;
	}
	
	public String getType() {
		return type;
	}

	/**
	 * @return the column
	 */
	public int getColumn() {
		return column;
	}

	/**
	 * @param column the column to set
	 */
	public void setColumn(int column) {
		this.column = column;
	}

	/**
	 * @return the line
	 */
	public int getLine() {
		return line;
	}

	/**
	 * @param line the line to set
	 */
	public void setLine(int line) {
		this.line = line;
	}
	

}
