/**
 *
 * This is part of the MoDeST-Plugin
 * Saarland University 2006
 * Author: Christophe Boutter (boutter@ps.uni-sb.de)
 *
 */
package modesteditor.core.modest;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

public class ModestEditorMessages {

	private static final String RESOURCE_BUNDLE= "modesteditor.core.ModestEditorMessages";//$NON-NLS-1$

	private static ResourceBundle fgResourceBundle= ResourceBundle.getBundle(RESOURCE_BUNDLE);

	private ModestEditorMessages() {
	}

	public static String getString(String key) {
		try {
			return fgResourceBundle.getString(key);
		} catch (MissingResourceException e) {
			return "!" + key + "!";//$NON-NLS-2$ //$NON-NLS-1$
		}
	}	

	public static ResourceBundle getResourceBundle() {
		return fgResourceBundle;
	}
}
