// $ANTLR 2.7.7 (20061129): "parser.g" -> "ModestOutlineTreeWalker.java"$

package modesteditor.core.antlrparser;

import modesteditor.core.ModestEditor;
    
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream; 
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;

import org.eclipse.jface.text.IDocument; 
import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.IRegion;
import org.eclipse.jface.text.Region;

import antlr.CommonAST;  
import antlr.RecognitionException;

import antlr.TreeParser;
import antlr.Token;
import antlr.collections.AST;
import antlr.RecognitionException;
import antlr.ANTLRException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.collections.impl.BitSet;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;
import modesteditor.core.model.Process;
import modesteditor.core.model.*;
import java.util.ArrayList;
import java.util.Vector;


public class ModestOutlineTreeWalker extends antlr.TreeParser       implements ModestOutlineTreeWalkerTokenTypes
 {
 //Additional Methods
	protected String errorMessage = "";
	protected boolean valid = true;
	
	public boolean OK() {
		return valid;
	}
	
	public String error() {
		return errorMessage;
	}
public ModestOutlineTreeWalker() {
	tokenNames = _tokenNames;
}

	public final Process  start(AST _t) throws RecognitionException {
		Process root = new Process("root",0,0);
		
		ModestAST start_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		
				ArrayList<Model> decl;
			
		
		try {      // for error handling
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case DEFAULTS:
			{
				AST __t258 = _t;
				ModestAST tmp62_AST_in = (ModestAST)_t;
				match(_t,DEFAULTS);
				_t = _t.getFirstChild();
				{
				_loop260:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_t.getType()==ASSIGN)) {
						ModestAST tmp63_AST_in = (ModestAST)_t;
						match(_t,ASSIGN);
						_t = _t.getNextSibling();
						ModestAST tmp64_AST_in = (ModestAST)_t;
						match(_t,IDENTIFIER);
						_t = _t.getNextSibling();
						ModestAST tmp65_AST_in = (ModestAST)_t;
						match(_t,IDENTIFIER);
						_t = _t.getNextSibling();
					}
					else {
						break _loop260;
					}
					
				} while (true);
				}
				_t = __t258;
				_t = _t.getNextSibling();
				break;
			}
			case STOP:
			case ALT:
			case DO:
			case BREAK:
			case PAR:
			case TRY:
			case THROW:
			case RELABEL:
			case HIDE:
			case EXTEND:
			case ASSIGN:
			case PLUS_ASSIGN:
			case MINUS_ASSIGN:
			case MULT_ASSIGN:
			case DIV_ASSIGN:
			case MOD_ASSIGN:
			case SR_ASSIGN:
			case SL_ASSIGN:
			case BAND_ASSIGN:
			case BXOR_ASSIGN:
			case BOR_ASSIGN:
			case IDENTIFIER:
			case VARIABLE_DECLARATION_AST:
			case PROCESS_DEFINITION_AST:
			case TYPE_DEFINITION_AST:
			case PROCESS_INSTANTIATION_AST:
			case GUARD_AST:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
			}
			{
			decl=description(_t);
			_t = _retTree;
			if ( inputState.guessing==0 ) {
				
						root.addModels(decl);
					
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						errorMessage = ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
		return root;
	}
	
	public final ArrayList<Model>  description(AST _t) throws RecognitionException {
		ArrayList<Model> decl = new ArrayList<Model>();
		
		ModestAST description_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		
			ArrayList<Model> stmnt;	
		
		
		try {      // for error handling
			{
			_loop264:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==VARIABLE_DECLARATION_AST||_t.getType()==PROCESS_DEFINITION_AST||_t.getType()==TYPE_DEFINITION_AST)) {
					stmnt=declarative_stmnt(_t);
					_t = _retTree;
					if ( inputState.guessing==0 ) {
						decl.addAll(stmnt);
					}
				}
				else {
					break _loop264;
				}
				
			} while (true);
			}
			seq_process(_t);
			_t = _retTree;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#description_in);*/
				
						errorMessage = ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
		return decl;
	}
	
	public final ArrayList<Model>  declarative_stmnt(AST _t) throws RecognitionException {
		ArrayList<Model> stmnt = new ArrayList<Model>();
		
		ModestAST declarative_stmnt_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		ModestAST p = null;
		ModestAST ty = null;
		ModestAST t = null;
		ModestAST i = null;
		ModestAST e = null;
		ModestAST id2 = null;
		
			ArrayList<Model> procChildren = new ArrayList<Model>();	
			Process proc = null;
		
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case PROCESS_DEFINITION_AST:
			{
				AST __t266 = _t;
				p = _t==ASTNULL ? null :(ModestAST)_t;
				match(_t,PROCESS_DEFINITION_AST);
				_t = _t.getFirstChild();
				param_definition(_t);
				_t = _retTree;
				{
				if (_t==null) _t=ASTNULL;
				switch ( _t.getType()) {
				case STOP:
				case ALT:
				case DO:
				case BREAK:
				case PAR:
				case TRY:
				case THROW:
				case RELABEL:
				case HIDE:
				case EXTEND:
				case ASSIGN:
				case PLUS_ASSIGN:
				case MINUS_ASSIGN:
				case MULT_ASSIGN:
				case DIV_ASSIGN:
				case MOD_ASSIGN:
				case SR_ASSIGN:
				case SL_ASSIGN:
				case BAND_ASSIGN:
				case BXOR_ASSIGN:
				case BOR_ASSIGN:
				case IDENTIFIER:
				case VARIABLE_DECLARATION_AST:
				case PROCESS_DEFINITION_AST:
				case TYPE_DEFINITION_AST:
				case PROCESS_INSTANTIATION_AST:
				case GUARD_AST:
				{
					procChildren=description(_t);
					_t = _retTree;
					break;
				}
				case 3:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(_t);
				}
				}
				}
				_t = __t266;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					proc = new Process(p.getProcName(), p.getLine(), p.getColumn()); 
						proc.addModels(procChildren);
						stmnt.add(proc);
						
				}
				break;
			}
			case TYPE_DEFINITION_AST:
			{
				ty = (ModestAST)_t;
				match(_t,TYPE_DEFINITION_AST);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					stmnt.add(new ModestType(ty.getSymbolType(), ty.getLine(), ty.getColumn(), ty.getTypeKind()));
				}
				break;
			}
			case VARIABLE_DECLARATION_AST:
			{
				AST __t268 = _t;
				ModestAST tmp66_AST_in = (ModestAST)_t;
				match(_t,VARIABLE_DECLARATION_AST);
				_t = _t.getFirstChild();
				{
				int _cnt274=0;
				_loop274:
				do {
					if (_t==null) _t=ASTNULL;
					switch ( _t.getType()) {
					case TYPE_AST:
					{
						AST __t270 = _t;
						t = _t==ASTNULL ? null :(ModestAST)_t;
						match(_t,TYPE_AST);
						_t = _t.getFirstChild();
						{
						int _cnt272=0;
						_loop272:
						do {
							if (_t==null) _t=ASTNULL;
							if ((_t.getType()==IDENTIFIER)) {
								i = (ModestAST)_t;
								match(_t,IDENTIFIER);
								_t = _t.getNextSibling();
								if ( inputState.guessing==0 ) {
									if (t.getText().equals("action")) stmnt.add(new ModestAction(i.getText(), i.getLine(), i.getColumn()));
										  	else if (t.getText().equals("exception")) stmnt.add(new ModestException(i.getText(), i.getLine(), i.getColumn())); 
										  	else stmnt.add(new ModestVariable(i.getText(), i.getLine(), i.getColumn(), t.getText()));
										
								}
							}
							else {
								if ( _cnt272>=1 ) { break _loop272; } else {throw new NoViableAltException(_t);}
							}
							
							_cnt272++;
						} while (true);
						}
						_t = __t270;
						_t = _t.getNextSibling();
						break;
					}
					case ASSIGN:
					{
						AST __t273 = _t;
						e = _t==ASTNULL ? null :(ModestAST)_t;
						match(_t,ASSIGN);
						_t = _t.getFirstChild();
						id2 = (ModestAST)_t;
						match(_t,IDENTIFIER);
						_t = _t.getNextSibling();
						expression(_t);
						_t = _retTree;
						if ( inputState.guessing==0 ) {
							stmnt.add(new ModestVariable(id2.getText(), id2.getLine(), id2.getColumn(), e.getSymbol().getType()));
						}
						_t = __t273;
						_t = _t.getNextSibling();
						break;
					}
					default:
					{
						if ( _cnt274>=1 ) { break _loop274; } else {throw new NoViableAltException(_t);}
					}
					}
					_cnt274++;
				} while (true);
				}
				_t = __t268;
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#declarative_stmnt_in);*/
				
						errorMessage = ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
		return stmnt;
	}
	
	public final void seq_process(AST _t) throws RecognitionException {
		
		ModestAST seq_process_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		
		try {      // for error handling
			{
			int _cnt281=0;
			_loop281:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_tokenSet_0.member(_t.getType()))) {
					local_process(_t);
					_t = _retTree;
				}
				else {
					if ( _cnt281>=1 ) { break _loop281; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt281++;
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#seq_process_in);*/
				
						errorMessage = ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final void param_definition(AST _t) throws RecognitionException {
		
		ModestAST param_definition_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		
		try {      // for error handling
			AST __t276 = _t;
			ModestAST tmp67_AST_in = (ModestAST)_t;
			match(_t,PARAMETER_LIST_AST);
			_t = _t.getFirstChild();
			{
			_loop278:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==VARIABLE_DECLARATION_AST)) {
					ModestAST tmp68_AST_in = (ModestAST)_t;
					match(_t,VARIABLE_DECLARATION_AST);
					_t = _t.getNextSibling();
				}
				else {
					break _loop278;
				}
				
			} while (true);
			}
			_t = __t276;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#param_definition_in);*/
				
						errorMessage = ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final void expression(AST _t) throws RecognitionException {
		
		ModestAST expression_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		ModestAST i = null;
		ModestAST f = null;
		ModestAST tp = null;
		
		try {      // for error handling
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case MULT:
			{
				AST __t349 = _t;
				ModestAST tmp69_AST_in = (ModestAST)_t;
				match(_t,MULT);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t349;
				_t = _t.getNextSibling();
				break;
			}
			case DIV:
			{
				AST __t350 = _t;
				ModestAST tmp70_AST_in = (ModestAST)_t;
				match(_t,DIV);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t350;
				_t = _t.getNextSibling();
				break;
			}
			case MOD:
			{
				AST __t351 = _t;
				ModestAST tmp71_AST_in = (ModestAST)_t;
				match(_t,MOD);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t351;
				_t = _t.getNextSibling();
				break;
			}
			case AMPERSAND:
			{
				AST __t352 = _t;
				ModestAST tmp72_AST_in = (ModestAST)_t;
				match(_t,AMPERSAND);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t352;
				_t = _t.getNextSibling();
				break;
			}
			case BOR:
			{
				AST __t353 = _t;
				ModestAST tmp73_AST_in = (ModestAST)_t;
				match(_t,BOR);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t353;
				_t = _t.getNextSibling();
				break;
			}
			case EOR:
			{
				AST __t354 = _t;
				ModestAST tmp74_AST_in = (ModestAST)_t;
				match(_t,EOR);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t354;
				_t = _t.getNextSibling();
				break;
			}
			case SHIFTL:
			{
				AST __t355 = _t;
				ModestAST tmp75_AST_in = (ModestAST)_t;
				match(_t,SHIFTL);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t355;
				_t = _t.getNextSibling();
				break;
			}
			case SHIFTR:
			{
				AST __t356 = _t;
				ModestAST tmp76_AST_in = (ModestAST)_t;
				match(_t,SHIFTR);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t356;
				_t = _t.getNextSibling();
				break;
			}
			case LT_OP:
			{
				AST __t357 = _t;
				ModestAST tmp77_AST_in = (ModestAST)_t;
				match(_t,LT_OP);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t357;
				_t = _t.getNextSibling();
				break;
			}
			case GT_OP:
			{
				AST __t358 = _t;
				ModestAST tmp78_AST_in = (ModestAST)_t;
				match(_t,GT_OP);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t358;
				_t = _t.getNextSibling();
				break;
			}
			case LE_OP:
			{
				AST __t359 = _t;
				ModestAST tmp79_AST_in = (ModestAST)_t;
				match(_t,LE_OP);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t359;
				_t = _t.getNextSibling();
				break;
			}
			case GE_OP:
			{
				AST __t360 = _t;
				ModestAST tmp80_AST_in = (ModestAST)_t;
				match(_t,GE_OP);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t360;
				_t = _t.getNextSibling();
				break;
			}
			case EQ_OP:
			{
				AST __t361 = _t;
				ModestAST tmp81_AST_in = (ModestAST)_t;
				match(_t,EQ_OP);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t361;
				_t = _t.getNextSibling();
				break;
			}
			case NE_OP:
			{
				AST __t362 = _t;
				ModestAST tmp82_AST_in = (ModestAST)_t;
				match(_t,NE_OP);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t362;
				_t = _t.getNextSibling();
				break;
			}
			case AND_OP:
			{
				AST __t363 = _t;
				ModestAST tmp83_AST_in = (ModestAST)_t;
				match(_t,AND_OP);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t363;
				_t = _t.getNextSibling();
				break;
			}
			case OR_OP:
			{
				AST __t364 = _t;
				ModestAST tmp84_AST_in = (ModestAST)_t;
				match(_t,OR_OP);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t364;
				_t = _t.getNextSibling();
				break;
			}
			case NOT_OP:
			{
				AST __t367 = _t;
				ModestAST tmp85_AST_in = (ModestAST)_t;
				match(_t,NOT_OP);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				_t = __t367;
				_t = _t.getNextSibling();
				break;
			}
			case HASH:
			{
				AST __t368 = _t;
				ModestAST tmp86_AST_in = (ModestAST)_t;
				match(_t,HASH);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				_t = __t368;
				_t = _t.getNextSibling();
				break;
			}
			case QUESTION:
			{
				AST __t369 = _t;
				ModestAST tmp87_AST_in = (ModestAST)_t;
				match(_t,QUESTION);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t369;
				_t = _t.getNextSibling();
				break;
			}
			case INT:
			{
				i = (ModestAST)_t;
				match(_t,INT);
				_t = _t.getNextSibling();
				break;
			}
			case FLOAT:
			{
				f = (ModestAST)_t;
				match(_t,FLOAT);
				_t = _t.getNextSibling();
				break;
			}
			case TYPE_AST:
			{
				tp = (ModestAST)_t;
				match(_t,TYPE_AST);
				_t = _t.getNextSibling();
				break;
			}
			case FUNCTION_CALL_AST:
			{
				AST __t370 = _t;
				ModestAST tmp88_AST_in = (ModestAST)_t;
				match(_t,FUNCTION_CALL_AST);
				_t = _t.getFirstChild();
				{
				_loop372:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_tokenSet_1.member(_t.getType()))) {
						expression(_t);
						_t = _retTree;
					}
					else {
						break _loop372;
					}
					
				} while (true);
				}
				_t = __t370;
				_t = _t.getNextSibling();
				break;
			}
			case LBRACKET:
			{
				AST __t373 = _t;
				ModestAST tmp89_AST_in = (ModestAST)_t;
				match(_t,LBRACKET);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t373;
				_t = _t.getNextSibling();
				break;
			}
			case DOT:
			{
				AST __t374 = _t;
				ModestAST tmp90_AST_in = (ModestAST)_t;
				match(_t,DOT);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				ModestAST tmp91_AST_in = (ModestAST)_t;
				match(_t,IDENTIFIER);
				_t = _t.getNextSibling();
				_t = __t374;
				_t = _t.getNextSibling();
				break;
			}
			case IDENTIFIER:
			{
				ModestAST tmp92_AST_in = (ModestAST)_t;
				match(_t,IDENTIFIER);
				_t = _t.getNextSibling();
				break;
			}
			case LCURL:
			{
				set(_t);
				_t = _retTree;
				break;
			}
			default:
				boolean synPredMatched343 = false;
				if (_t==null) _t=ASTNULL;
				if (((_t.getType()==PLUS))) {
					AST __t343 = _t;
					synPredMatched343 = true;
					inputState.guessing++;
					try {
						{
						AST __t342 = _t;
						ModestAST tmp93_AST_in = (ModestAST)_t;
						match(_t,PLUS);
						_t = _t.getFirstChild();
						expression(_t);
						_t = _retTree;
						expression(_t);
						_t = _retTree;
						_t = __t342;
						_t = _t.getNextSibling();
						}
					}
					catch (RecognitionException pe) {
						synPredMatched343 = false;
					}
					_t = __t343;
inputState.guessing--;
				}
				if ( synPredMatched343 ) {
					AST __t344 = _t;
					ModestAST tmp94_AST_in = (ModestAST)_t;
					match(_t,PLUS);
					_t = _t.getFirstChild();
					expression(_t);
					_t = _retTree;
					expression(_t);
					_t = _retTree;
					_t = __t344;
					_t = _t.getNextSibling();
				}
				else {
					boolean synPredMatched347 = false;
					if (_t==null) _t=ASTNULL;
					if (((_t.getType()==MINUS))) {
						AST __t347 = _t;
						synPredMatched347 = true;
						inputState.guessing++;
						try {
							{
							AST __t346 = _t;
							ModestAST tmp95_AST_in = (ModestAST)_t;
							match(_t,MINUS);
							_t = _t.getFirstChild();
							expression(_t);
							_t = _retTree;
							expression(_t);
							_t = _retTree;
							_t = __t346;
							_t = _t.getNextSibling();
							}
						}
						catch (RecognitionException pe) {
							synPredMatched347 = false;
						}
						_t = __t347;
inputState.guessing--;
					}
					if ( synPredMatched347 ) {
						AST __t348 = _t;
						ModestAST tmp96_AST_in = (ModestAST)_t;
						match(_t,MINUS);
						_t = _t.getFirstChild();
						expression(_t);
						_t = _retTree;
						expression(_t);
						_t = _retTree;
						_t = __t348;
						_t = _t.getNextSibling();
					}
					else if ((_t.getType()==PLUS)) {
						AST __t365 = _t;
						ModestAST tmp97_AST_in = (ModestAST)_t;
						match(_t,PLUS);
						_t = _t.getFirstChild();
						expression(_t);
						_t = _retTree;
						_t = __t365;
						_t = _t.getNextSibling();
					}
					else if ((_t.getType()==MINUS)) {
						AST __t366 = _t;
						ModestAST tmp98_AST_in = (ModestAST)_t;
						match(_t,MINUS);
						_t = _t.getFirstChild();
						expression(_t);
						_t = _retTree;
						_t = __t366;
						_t = _t.getNextSibling();
					}
				else {
					throw new NoViableAltException(_t);
				}
				}}
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					
							/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
							pr.pr_tree(#expression_in);*/
					
							errorMessage = ex.getMessage();
							this.valid = false;
						
				} else {
					throw ex;
				}
			}
			_retTree = _t;
		}
		
	public final void local_process(AST _t) throws RecognitionException {
		
		ModestAST local_process_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		
		try {      // for error handling
			{
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case STOP:
			{
				ModestAST tmp99_AST_in = (ModestAST)_t;
				match(_t,STOP);
				_t = _t.getNextSibling();
				break;
			}
			case BREAK:
			{
				ModestAST tmp100_AST_in = (ModestAST)_t;
				match(_t,BREAK);
				_t = _t.getNextSibling();
				break;
			}
			case THROW:
			{
				AST __t284 = _t;
				ModestAST tmp101_AST_in = (ModestAST)_t;
				match(_t,THROW);
				_t = _t.getFirstChild();
				ModestAST tmp102_AST_in = (ModestAST)_t;
				match(_t,IDENTIFIER);
				_t = _t.getNextSibling();
				_t = __t284;
				_t = _t.getNextSibling();
				break;
			}
			case TRY:
			{
				AST __t285 = _t;
				ModestAST tmp103_AST_in = (ModestAST)_t;
				match(_t,TRY);
				_t = _t.getFirstChild();
				description(_t);
				_t = _retTree;
				{
				int _cnt288=0;
				_loop288:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_t.getType()==CATCH_DEFINITION_AST)) {
						AST __t287 = _t;
						ModestAST tmp104_AST_in = (ModestAST)_t;
						match(_t,CATCH_DEFINITION_AST);
						_t = _t.getFirstChild();
						ModestAST tmp105_AST_in = (ModestAST)_t;
						match(_t,IDENTIFIER);
						_t = _t.getNextSibling();
						description(_t);
						_t = _retTree;
						_t = __t287;
						_t = _t.getNextSibling();
					}
					else {
						if ( _cnt288>=1 ) { break _loop288; } else {throw new NoViableAltException(_t);}
					}
					
					_cnt288++;
				} while (true);
				}
				_t = __t285;
				_t = _t.getNextSibling();
				break;
			}
			case HIDE:
			{
				AST __t289 = _t;
				ModestAST tmp106_AST_in = (ModestAST)_t;
				match(_t,HIDE);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				seq_process(_t);
				_t = _retTree;
				_t = __t289;
				_t = _t.getNextSibling();
				break;
			}
			case EXTEND:
			{
				AST __t290 = _t;
				ModestAST tmp107_AST_in = (ModestAST)_t;
				match(_t,EXTEND);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				seq_process(_t);
				_t = _retTree;
				_t = __t290;
				_t = _t.getNextSibling();
				break;
			}
			case RELABEL:
			{
				AST __t291 = _t;
				ModestAST tmp108_AST_in = (ModestAST)_t;
				match(_t,RELABEL);
				_t = _t.getFirstChild();
				{
				AST __t293 = _t;
				ModestAST tmp109_AST_in = (ModestAST)_t;
				match(_t,BY);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t293;
				_t = _t.getNextSibling();
				}
				seq_process(_t);
				_t = _retTree;
				_t = __t291;
				_t = _t.getNextSibling();
				break;
			}
			case GUARD_AST:
			{
				AST __t294 = _t;
				ModestAST tmp110_AST_in = (ModestAST)_t;
				match(_t,GUARD_AST);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				seq_process(_t);
				_t = _retTree;
				_t = __t294;
				_t = _t.getNextSibling();
				break;
			}
			case ALT:
			{
				alt_stmnt(_t);
				_t = _retTree;
				break;
			}
			case PAR:
			{
				par_stmnt(_t);
				_t = _retTree;
				break;
			}
			case DO:
			{
				do_stmnt(_t);
				_t = _retTree;
				break;
			}
			case PROCESS_INSTANTIATION_AST:
			{
				AST __t295 = _t;
				ModestAST tmp111_AST_in = (ModestAST)_t;
				match(_t,PROCESS_INSTANTIATION_AST);
				_t = _t.getFirstChild();
				{
				_loop297:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_tokenSet_1.member(_t.getType()))) {
						expression(_t);
						_t = _retTree;
					}
					else {
						break _loop297;
					}
					
				} while (true);
				}
				_t = __t295;
				_t = _t.getNextSibling();
				break;
			}
			case ASSIGN:
			case PLUS_ASSIGN:
			case MINUS_ASSIGN:
			case MULT_ASSIGN:
			case DIV_ASSIGN:
			case MOD_ASSIGN:
			case SR_ASSIGN:
			case SL_ASSIGN:
			case BAND_ASSIGN:
			case BXOR_ASSIGN:
			case BOR_ASSIGN:
			{
				assignment(_t);
				_t = _retTree;
				break;
			}
			default:
				boolean synPredMatched300 = false;
				if (_t==null) _t=ASTNULL;
				if (((_t.getType()==IDENTIFIER))) {
					AST __t300 = _t;
					synPredMatched300 = true;
					inputState.guessing++;
					try {
						{
						AST __t299 = _t;
						ModestAST tmp112_AST_in = (ModestAST)_t;
						match(_t,IDENTIFIER);
						_t = _t.getFirstChild();
						ModestAST tmp113_AST_in = (ModestAST)_t;
						match(_t,PALT);
						_t = _t.getNextSibling();
						_t = __t299;
						_t = _t.getNextSibling();
						}
					}
					catch (RecognitionException pe) {
						synPredMatched300 = false;
					}
					_t = __t300;
inputState.guessing--;
				}
				if ( synPredMatched300 ) {
					palt_stmnt(_t);
					_t = _retTree;
				}
				else if ((_t.getType()==IDENTIFIER)) {
					ModestAST tmp114_AST_in = (ModestAST)_t;
					match(_t,IDENTIFIER);
					_t = _t.getNextSibling();
				}
			else {
				throw new NoViableAltException(_t);
			}
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#local_process_in);*/
				
						errorMessage = ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final void alt_stmnt(AST _t) throws RecognitionException {
		
		ModestAST alt_stmnt_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		
		try {      // for error handling
			AST __t302 = _t;
			ModestAST tmp115_AST_in = (ModestAST)_t;
			match(_t,ALT);
			_t = _t.getFirstChild();
			{
			int _cnt305=0;
			_loop305:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==DCOLON)) {
					AST __t304 = _t;
					ModestAST tmp116_AST_in = (ModestAST)_t;
					match(_t,DCOLON);
					_t = _t.getFirstChild();
					seq_process(_t);
					_t = _retTree;
					_t = __t304;
					_t = _t.getNextSibling();
				}
				else {
					if ( _cnt305>=1 ) { break _loop305; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt305++;
			} while (true);
			}
			_t = __t302;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#alt_stmnt_in);*/
				
						errorMessage = ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final void par_stmnt(AST _t) throws RecognitionException {
		
		ModestAST par_stmnt_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		
		try {      // for error handling
			AST __t307 = _t;
			ModestAST tmp117_AST_in = (ModestAST)_t;
			match(_t,PAR);
			_t = _t.getFirstChild();
			{
			int _cnt310=0;
			_loop310:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==DCOLON)) {
					AST __t309 = _t;
					ModestAST tmp118_AST_in = (ModestAST)_t;
					match(_t,DCOLON);
					_t = _t.getFirstChild();
					seq_process(_t);
					_t = _retTree;
					_t = __t309;
					_t = _t.getNextSibling();
				}
				else {
					if ( _cnt310>=1 ) { break _loop310; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt310++;
			} while (true);
			}
			_t = __t307;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#par_stmnt_in);*/
				
						errorMessage = ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final void do_stmnt(AST _t) throws RecognitionException {
		
		ModestAST do_stmnt_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		
		try {      // for error handling
			AST __t312 = _t;
			ModestAST tmp119_AST_in = (ModestAST)_t;
			match(_t,DO);
			_t = _t.getFirstChild();
			{
			int _cnt315=0;
			_loop315:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==DCOLON)) {
					AST __t314 = _t;
					ModestAST tmp120_AST_in = (ModestAST)_t;
					match(_t,DCOLON);
					_t = _t.getFirstChild();
					seq_process(_t);
					_t = _retTree;
					_t = __t314;
					_t = _t.getNextSibling();
				}
				else {
					if ( _cnt315>=1 ) { break _loop315; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt315++;
			} while (true);
			}
			_t = __t312;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#do_stmnt_in);*/
				
						errorMessage = ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final void assignment(AST _t) throws RecognitionException {
		
		ModestAST assignment_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case ASSIGN:
			{
				AST __t328 = _t;
				ModestAST tmp121_AST_in = (ModestAST)_t;
				match(_t,ASSIGN);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t328;
				_t = _t.getNextSibling();
				break;
			}
			case PLUS_ASSIGN:
			{
				AST __t329 = _t;
				ModestAST tmp122_AST_in = (ModestAST)_t;
				match(_t,PLUS_ASSIGN);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t329;
				_t = _t.getNextSibling();
				break;
			}
			case MINUS_ASSIGN:
			{
				AST __t330 = _t;
				ModestAST tmp123_AST_in = (ModestAST)_t;
				match(_t,MINUS_ASSIGN);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t330;
				_t = _t.getNextSibling();
				break;
			}
			case MULT_ASSIGN:
			{
				AST __t331 = _t;
				ModestAST tmp124_AST_in = (ModestAST)_t;
				match(_t,MULT_ASSIGN);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t331;
				_t = _t.getNextSibling();
				break;
			}
			case DIV_ASSIGN:
			{
				AST __t332 = _t;
				ModestAST tmp125_AST_in = (ModestAST)_t;
				match(_t,DIV_ASSIGN);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t332;
				_t = _t.getNextSibling();
				break;
			}
			case MOD_ASSIGN:
			{
				AST __t333 = _t;
				ModestAST tmp126_AST_in = (ModestAST)_t;
				match(_t,MOD_ASSIGN);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t333;
				_t = _t.getNextSibling();
				break;
			}
			case SR_ASSIGN:
			{
				AST __t334 = _t;
				ModestAST tmp127_AST_in = (ModestAST)_t;
				match(_t,SR_ASSIGN);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t334;
				_t = _t.getNextSibling();
				break;
			}
			case SL_ASSIGN:
			{
				AST __t335 = _t;
				ModestAST tmp128_AST_in = (ModestAST)_t;
				match(_t,SL_ASSIGN);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t335;
				_t = _t.getNextSibling();
				break;
			}
			case BAND_ASSIGN:
			{
				AST __t336 = _t;
				ModestAST tmp129_AST_in = (ModestAST)_t;
				match(_t,BAND_ASSIGN);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t336;
				_t = _t.getNextSibling();
				break;
			}
			case BXOR_ASSIGN:
			{
				AST __t337 = _t;
				ModestAST tmp130_AST_in = (ModestAST)_t;
				match(_t,BXOR_ASSIGN);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t337;
				_t = _t.getNextSibling();
				break;
			}
			case BOR_ASSIGN:
			{
				AST __t338 = _t;
				ModestAST tmp131_AST_in = (ModestAST)_t;
				match(_t,BOR_ASSIGN);
				_t = _t.getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t338;
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#assignment_in);*/
				
						errorMessage = ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final void palt_stmnt(AST _t) throws RecognitionException {
		
		ModestAST palt_stmnt_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		
		try {      // for error handling
			AST __t317 = _t;
			ModestAST tmp132_AST_in = (ModestAST)_t;
			match(_t,IDENTIFIER);
			_t = _t.getFirstChild();
			AST __t318 = _t;
			ModestAST tmp133_AST_in = (ModestAST)_t;
			match(_t,PALT);
			_t = _t.getFirstChild();
			{
			int _cnt326=0;
			_loop326:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==WEIGHT_AST)) {
					AST __t320 = _t;
					ModestAST tmp134_AST_in = (ModestAST)_t;
					match(_t,WEIGHT_AST);
					_t = _t.getFirstChild();
					{
					if (_t==null) _t=ASTNULL;
					switch ( _t.getType()) {
					case ASSIGN_START:
					{
						AST __t322 = _t;
						ModestAST tmp135_AST_in = (ModestAST)_t;
						match(_t,ASSIGN_START);
						_t = _t.getFirstChild();
						{
						int _cnt324=0;
						_loop324:
						do {
							if (_t==null) _t=ASTNULL;
							if (((_t.getType() >= ASSIGN && _t.getType() <= BOR_ASSIGN))) {
								assignment(_t);
								_t = _retTree;
							}
							else {
								if ( _cnt324>=1 ) { break _loop324; } else {throw new NoViableAltException(_t);}
							}
							
							_cnt324++;
						} while (true);
						}
						_t = __t322;
						_t = _t.getNextSibling();
						break;
					}
					case 3:
					case STOP:
					case ALT:
					case DO:
					case BREAK:
					case PAR:
					case TRY:
					case THROW:
					case RELABEL:
					case HIDE:
					case EXTEND:
					case ASSIGN:
					case PLUS_ASSIGN:
					case MINUS_ASSIGN:
					case MULT_ASSIGN:
					case DIV_ASSIGN:
					case MOD_ASSIGN:
					case SR_ASSIGN:
					case SL_ASSIGN:
					case BAND_ASSIGN:
					case BXOR_ASSIGN:
					case BOR_ASSIGN:
					case IDENTIFIER:
					case PROCESS_INSTANTIATION_AST:
					case GUARD_AST:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(_t);
					}
					}
					}
					{
					if (_t==null) _t=ASTNULL;
					switch ( _t.getType()) {
					case STOP:
					case ALT:
					case DO:
					case BREAK:
					case PAR:
					case TRY:
					case THROW:
					case RELABEL:
					case HIDE:
					case EXTEND:
					case ASSIGN:
					case PLUS_ASSIGN:
					case MINUS_ASSIGN:
					case MULT_ASSIGN:
					case DIV_ASSIGN:
					case MOD_ASSIGN:
					case SR_ASSIGN:
					case SL_ASSIGN:
					case BAND_ASSIGN:
					case BXOR_ASSIGN:
					case BOR_ASSIGN:
					case IDENTIFIER:
					case PROCESS_INSTANTIATION_AST:
					case GUARD_AST:
					{
						seq_process(_t);
						_t = _retTree;
						break;
					}
					case 3:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(_t);
					}
					}
					}
					_t = __t320;
					_t = _t.getNextSibling();
				}
				else {
					if ( _cnt326>=1 ) { break _loop326; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt326++;
			} while (true);
			}
			_t = __t318;
			_t = _t.getNextSibling();
			_t = __t317;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#palt_stmnt_in);*/
				
						errorMessage = ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final void set(AST _t) throws RecognitionException {
		
		ModestAST set_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		
		try {      // for error handling
			AST __t378 = _t;
			ModestAST tmp136_AST_in = (ModestAST)_t;
			match(_t,LCURL);
			_t = _t.getFirstChild();
			{
			int _cnt380=0;
			_loop380:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_tokenSet_2.member(_t.getType()))) {
					set_element(_t);
					_t = _retTree;
				}
				else {
					if ( _cnt380>=1 ) { break _loop380; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt380++;
			} while (true);
			}
			_t = __t378;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#set_in);*/
				
						errorMessage = ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final void range(AST _t) throws RecognitionException {
		
		ModestAST range_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		
		try {      // for error handling
			AST __t376 = _t;
			ModestAST tmp137_AST_in = (ModestAST)_t;
			match(_t,DOTDOT);
			_t = _t.getFirstChild();
			expression(_t);
			_t = _retTree;
			expression(_t);
			_t = _retTree;
			_t = __t376;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#range_in);*/
				
						errorMessage = ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final void set_element(AST _t) throws RecognitionException {
		
		ModestAST set_element_AST_in = (_t == ASTNULL) ? null : (ModestAST)_t;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case INT:
			{
				ModestAST tmp138_AST_in = (ModestAST)_t;
				match(_t,INT);
				_t = _t.getNextSibling();
				break;
			}
			case IDENTIFIER:
			{
				ModestAST tmp139_AST_in = (ModestAST)_t;
				match(_t,IDENTIFIER);
				_t = _t.getNextSibling();
				break;
			}
			case TYPE_AST:
			{
				ModestAST tmp140_AST_in = (ModestAST)_t;
				match(_t,TYPE_AST);
				_t = _t.getNextSibling();
				break;
			}
			case DOTDOT:
			{
				range(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				
						/*print_tree<RefModest_AST,BaseTreeParser> pr(*this);
						pr.pr_tree(#set_element_in);*/
				
						errorMessage = ex.getMessage();
						this.valid = false;
					
			} else {
				throw ex;
			}
		}
		_retTree = _t;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"typedef\"",
		"\"class\"",
		"\"const\"",
		"\"extern\"",
		"\"range\"",
		"\"enum\"",
		"\"struct\"",
		"\"set\"",
		"\"patient\"",
		"\"impatient\"",
		"\"STOP\"",
		"\"ERROR\"",
		"\"forall\"",
		"\"alt\"",
		"\"palt\"",
		"\"when\"",
		"\"urgent\"",
		"\"do\"",
		"\"break\"",
		"\"if\"",
		"\"else\"",
		"\"return\"",
		"\"par\"",
		"\"try\"",
		"\"throw\"",
		"\"catch\"",
		"\"process\"",
		"\"relabel\"",
		"\"by\"",
		"\"hide\"",
		"\"expose\"",
		"\"extend\"",
		"\"rewrite\"",
		"\"prefix\"",
		"\"package\"",
		"\"import\"",
		"\"export\"",
		"\"priority\"",
		"\"defaults\"",
		"\"|\"",
		"\"&\"",
		"\"^\"",
		"\"<<\"",
		"\">>\"",
		"\"!\"",
		"\"&&\"",
		"\"||\"",
		"\"==\"",
		"\"!=\"",
		"\"<\"",
		"\">\"",
		"\"<=\"",
		"\">=\"",
		"\"+\"",
		"\"-\"",
		"\"*\"",
		"\"/\"",
		"\"%\"",
		"\"(\"",
		"\")\"",
		"\"[\"",
		"\"]\"",
		"\"{\"",
		"\"}\"",
		"\"=\"",
		"\"+=\"",
		"\"-=\"",
		"\"*=\"",
		"\"/=\"",
		"\"%=\"",
		"\">>=\"",
		"\"<<=\"",
		"\"&=\"",
		"\"^=\"",
		"\"|=\"",
		"\"{=\"",
		"\"=}\"",
		"\"..\"",
		"\".\"",
		"\",\"",
		"\"?\"",
		"\"::\"",
		"\":\"",
		"\";\"",
		"\"@\"",
		"\"#\"",
		"INT",
		"FLOAT",
		"STRING",
		"an identifier",
		"EXPONENT_PART",
		"FLOAT_SUFFIX",
		"DOT_OR_DOTDOT",
		"NUMERIC",
		"a whitespace character",
		"'C-comment'",
		"CPP_COMMENT",
		"ESCAPE",
		"SHIFTR_OR_ASGN",
		"SHIFTL_OR_ASGN",
		"INTNUMERIC",
		"HASH_OR_LINENR",
		"IDENTIFIER_AST",
		"TYPE_AST",
		"VARIABLE_DECLARATION_AST",
		"FUNCTION_DEFINITION_AST",
		"PARAMETER_LIST_AST",
		"PROCESS_DEFINITION_AST",
		"CATCH_DEFINITION_AST",
		"TYPE_DEFINITION_AST",
		"FUNCTION_CALL_AST",
		"PROCESS_INSTANTIATION_AST",
		"WEIGHT_AST",
		"GUARD_AST",
		"TYPE_CAST"
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 45573357568L, 11258999605329904L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 4611677222334365696L, 1134696772927493L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 0L, 8796697133056L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	}
	
