// $ANTLR 2.7.7 (20061129): "ModestParser.g" -> "ModestTreeWalker.java"$

package modesteditor.core.antlrparser;

import modesteditor.core.ModestEditor;
    
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream; 
import java.util.ArrayList;

import org.eclipse.jface.text.IDocument; 
import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.IRegion;
import org.eclipse.jface.text.Region;

import antlr.CommonAST;  

public interface ModestParserTokenTypes {
	int EOF = 1;
	int NULL_TREE_LOOKAHEAD = 3;
	int LITERAL_defaults = 4;
	int LBRACE = 5;
	int LITERAL_actions = 6;
	int EQUAL = 7;
	int LITERAL_patient = 8;
	int LITERAL_impatient = 9;
	int SEMI = 10;
	int LITERAL_guards = 11;
	int LITERAL_urgent = 12;
	int LITERAL_not_urgent = 13;
	int RBRACE = 14;
	int LITERAL_action = 15;
	int ID = 16;
	int COMMA = 17;
	int LITERAL_float = 18;
	int FLOAT = 19;
	int LITERAL_int = 20;
	int INT = 21;
	int LITERAL_bool = 22;
	int LITERAL_true = 23;
	int LITERAL_false = 24;
	int LITERAL_clock = 25;
	int LITERAL_const = 26;
	int LITERAL_extern = 27;
	int LBRACKET = 28;
	int RBRACKET = 29;
	int LITERAL_exception = 30;
	int LITERAL_typedef = 31;
	int LITERAL_struct = 32;
	int LITERAL_set = 33;
	int LITERAL_range = 34;
	int DOTDOT = 35;
	int LITERAL_process = 36;
	int LPAR = 37;
	int RPAR = 38;
	int QUESTION = 39;
	int COLON = 40;
	int OROR = 41;
	int ANDAND = 42;
	int OR = 43;
	int XOR = 44;
	int AND = 45;
	int EQUALEQUAL = 46;
	int NOT_EQUAL = 47;
	int GT = 48;
	int LT = 49;
	int GTE = 50;
	int LTE = 51;
	int LEFTSHIFT = 52;
	int RIGHTSHIFT = 53;
	int ULEFTSHIFT = 54;
	int URIGHTSHIFT = 55;
	int PLUS = 56;
	int MINUS = 57;
	int TIMES = 58;
	int DIV = 59;
	int REMAINDER = 60;
	int NOT = 61;
	int DOT = 62;
	int LITERAL_try = 63;
	int LITERAL_catch = 64;
	int LITERAL_when = 65;
	int LITERAL_alt = 66;
	int LITERAL_do = 67;
	int LITERAL_par = 68;
	int LITERAL_hide = 69;
	int LITERAL_relabel = 70;
	int LITERAL_extend = 71;
	int LITERAL_prefix = 72;
	int LITERAL_by = 73;
	int PLUS_EQUAL = 74;
	int MINUS_EQUAL = 75;
	int TIME_EQUAL = 76;
	int DIV_EQUAL = 77;
	int REMAINDER_EQUAL = 78;
	int LSHIFT_EQUAL = 79;
	int RSHIFT_EQUAL = 80;
	int AND_EQUAL = 81;
	int OR_EQUAL = 82;
	int XOR_EQUAL = 83;
	int ULSHIFT_EQUAL = 84;
	int URSHIFT_EQUAL = 85;
	int LITERAL_palt = 86;
	int LITERAL_break = 87;
	int LITERAL_return = 88;
	int LITERAL_throw = 89;
	int EXPONENT_PART = 90;
	int FLOAT_SUFFIX = 91;
	int NUMERIC = 92;
	int WS = 93;
	int COMMENT = 94;
	int ML_COMMENT = 95;
	int CHAR = 96;
	int STRING = 97;
	int TWIDDLE = 98;
	int MINUSMINUS = 99;
	int PLUSPLUS = 100;
	int TIMES_EQUAL = 101;
}
