/**
 *
 * This is part of the MoDeST-Plugin
 * Saarland University 2006
 * Author: Christophe Boutter (boutter@ps.uni-sb.de)
 *
 */
package modesteditor.core.model;

/**
 * Model of a MoDeST exception.
 *
 */
public class ModestException extends Model {

	/* (non-Javadoc)
	 * @see modesteditor.core.model.Model#accept(modesteditor.core.model.IModelVisitor, java.lang.Object)
	 */
	@Override
	public void accept(IModelVisitor visitor, Object passAlongArgument) {
		visitor.visitModestException(this, passAlongArgument);
	}

	public ModestException(String name, int line, int column) {
		this.name = name;
		this.line = line;
		this.column = column;
		this.length = name.length();
	}
}
