/**
 *
 * This is part of the MoDeST-Plugin
 * Saarland University 2007
 * Author: Christophe Boutter (boutter@ps.uni-sb.de)
 *
 */
package modesteditor.core.stepsimulation;

import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

/**
 * Content provider for the step simulation.
 *
 */
/*public class SimulationContentProvider implements IStructuredContentProvider {

	
	public Object[] getElements(Object inputElement){
		//if (!((ArrayList)inputElement).isEmpty()) return ((ArrayList)inputElement).toArray();
		//else return null;
		return ((SimulationRoot)inputElement).getModels();
	}

	
	public void dispose() {}

	
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {}

}*/

public class SimulationContentProvider implements ITreeContentProvider {
	
	private static Object[] EMPTY_ARRAY = new Object[0];

	/** Returns the children models of the given Model (only processes can have children). */
	public Object[] getChildren (Object element) {
		
		return EMPTY_ARRAY;
	}

	/** Returns the parent model of the given model. */
	public Object getParent (Object element) {
		return null;//((Model)element).getParent();
	}

	/** Returns whether the given model has any children. */
	public boolean hasChildren (Object element) {
		
		 return false;
	}

	/** Returns the top-level models of the given program (which is
	 * conceptually the root of the tree, but is not displayed in the view).
	 * This method is called only on the object given to the tree viewer
	 * in setInput(). */
	public Object[] getElements (Object inputElement){
		return ((SimulationRoot)inputElement).getModels();
	}

	public void dispose () {}

	public void inputChanged (Viewer viewer, Object oldInput, Object newInput) {}

	/*protected Object[] concat(Object[] object, Object[] more, Object[] more2, Object[] more3, Object[] more4) {
		Object[] both = new Object[object.length + more.length + more2.length+ more3.length+ more4.length];
		System.arraycopy(object, 0, both, 0, object.length);
		System.arraycopy(more, 0, both, object.length, more.length);
		System.arraycopy(more2, 0, both, object.length + more.length, more2.length);		
		System.arraycopy(more3, 0, both, object.length + more.length, more3.length);
		System.arraycopy(more4, 0, both, object.length + more.length, more4.length);
		return both;
	}*/
	
}